// Code generated by go-swagger; DO NOT EDIT.

package azure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/vmware-tanzu/tanzu-framework/pkg/v1/tkg/web/server/models"
)

// CreateAzureResourceGroupReader is a Reader for the CreateAzureResourceGroup structure.
type CreateAzureResourceGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateAzureResourceGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewCreateAzureResourceGroupCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewCreateAzureResourceGroupBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewCreateAzureResourceGroupUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateAzureResourceGroupInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewCreateAzureResourceGroupCreated creates a CreateAzureResourceGroupCreated with default headers values
func NewCreateAzureResourceGroupCreated() *CreateAzureResourceGroupCreated {
	return &CreateAzureResourceGroupCreated{}
}

/*CreateAzureResourceGroupCreated handles this case with default header values.

Successfully created Azure resource group
*/
type CreateAzureResourceGroupCreated struct {
	Payload string
}

func (o *CreateAzureResourceGroupCreated) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/resourcegroups][%d] createAzureResourceGroupCreated  %+v", 201, o.Payload)
}

func (o *CreateAzureResourceGroupCreated) GetPayload() string {
	return o.Payload
}

func (o *CreateAzureResourceGroupCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateAzureResourceGroupBadRequest creates a CreateAzureResourceGroupBadRequest with default headers values
func NewCreateAzureResourceGroupBadRequest() *CreateAzureResourceGroupBadRequest {
	return &CreateAzureResourceGroupBadRequest{}
}

/*CreateAzureResourceGroupBadRequest handles this case with default header values.

Bad request
*/
type CreateAzureResourceGroupBadRequest struct {
	Payload *models.Error
}

func (o *CreateAzureResourceGroupBadRequest) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/resourcegroups][%d] createAzureResourceGroupBadRequest  %+v", 400, o.Payload)
}

func (o *CreateAzureResourceGroupBadRequest) GetPayload() *models.Error {
	return o.Payload
}

func (o *CreateAzureResourceGroupBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateAzureResourceGroupUnauthorized creates a CreateAzureResourceGroupUnauthorized with default headers values
func NewCreateAzureResourceGroupUnauthorized() *CreateAzureResourceGroupUnauthorized {
	return &CreateAzureResourceGroupUnauthorized{}
}

/*CreateAzureResourceGroupUnauthorized handles this case with default header values.

Incorrect credentials
*/
type CreateAzureResourceGroupUnauthorized struct {
	Payload *models.Error
}

func (o *CreateAzureResourceGroupUnauthorized) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/resourcegroups][%d] createAzureResourceGroupUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateAzureResourceGroupUnauthorized) GetPayload() *models.Error {
	return o.Payload
}

func (o *CreateAzureResourceGroupUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateAzureResourceGroupInternalServerError creates a CreateAzureResourceGroupInternalServerError with default headers values
func NewCreateAzureResourceGroupInternalServerError() *CreateAzureResourceGroupInternalServerError {
	return &CreateAzureResourceGroupInternalServerError{}
}

/*CreateAzureResourceGroupInternalServerError handles this case with default header values.

Internal server error
*/
type CreateAzureResourceGroupInternalServerError struct {
	Payload *models.Error
}

func (o *CreateAzureResourceGroupInternalServerError) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/resourcegroups][%d] createAzureResourceGroupInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateAzureResourceGroupInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *CreateAzureResourceGroupInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
