// Code generated by go-swagger; DO NOT EDIT.

package vsphere

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/vmware-tanzu/tanzu-framework/pkg/v1/tkg/web/server/models"
)

// NewSetVSphereEndpointParams creates a new SetVSphereEndpointParams object
// with the default values initialized.
func NewSetVSphereEndpointParams() *SetVSphereEndpointParams {
	var ()
	return &SetVSphereEndpointParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewSetVSphereEndpointParamsWithTimeout creates a new SetVSphereEndpointParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewSetVSphereEndpointParamsWithTimeout(timeout time.Duration) *SetVSphereEndpointParams {
	var ()
	return &SetVSphereEndpointParams{

		timeout: timeout,
	}
}

// NewSetVSphereEndpointParamsWithContext creates a new SetVSphereEndpointParams object
// with the default values initialized, and the ability to set a context for a request
func NewSetVSphereEndpointParamsWithContext(ctx context.Context) *SetVSphereEndpointParams {
	var ()
	return &SetVSphereEndpointParams{

		Context: ctx,
	}
}

// NewSetVSphereEndpointParamsWithHTTPClient creates a new SetVSphereEndpointParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewSetVSphereEndpointParamsWithHTTPClient(client *http.Client) *SetVSphereEndpointParams {
	var ()
	return &SetVSphereEndpointParams{
		HTTPClient: client,
	}
}

/*SetVSphereEndpointParams contains all the parameters to send to the API endpoint
for the set v sphere endpoint operation typically these are written to a http.Request
*/
type SetVSphereEndpointParams struct {

	/*Credentials
	  vSphere credentials

	*/
	Credentials *models.VSphereCredentials

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) WithTimeout(timeout time.Duration) *SetVSphereEndpointParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) WithContext(ctx context.Context) *SetVSphereEndpointParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) WithHTTPClient(client *http.Client) *SetVSphereEndpointParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCredentials adds the credentials to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) WithCredentials(credentials *models.VSphereCredentials) *SetVSphereEndpointParams {
	o.SetCredentials(credentials)
	return o
}

// SetCredentials adds the credentials to the set v sphere endpoint params
func (o *SetVSphereEndpointParams) SetCredentials(credentials *models.VSphereCredentials) {
	o.Credentials = credentials
}

// WriteToRequest writes these params to a swagger request
func (o *SetVSphereEndpointParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Credentials != nil {
		if err := r.SetBodyParam(o.Credentials); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
